package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.OaEmployeeTemplateBinding;
import com.ruoyi.oa.domain.vo.EmployeeSalaryRecordVo;
import com.ruoyi.oa.domain.vo.OaEmployeeTemplateBindingVo;
import com.ruoyi.oa.domain.bo.OaEmployeeTemplateBindingBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 员工模板绑定及月度发放记录Service接口
 *
 * @author ruoyi
 * @date 2025-06-23
 */
public interface IOaEmployeeTemplateBindingService {

    /**
     * 查询员工模板绑定及月度发放记录
     */
    OaEmployeeTemplateBindingVo queryById(Long bindingId);

    /**
     * 查询员工模板绑定及月度发放记录列表
     */
    TableDataInfo<OaEmployeeTemplateBindingVo> queryPageList(OaEmployeeTemplateBindingBo bo, PageQuery pageQuery);

    /**
     * 查询员工模板绑定及月度发放记录列表
     */
    List<OaEmployeeTemplateBindingVo> queryList(OaEmployeeTemplateBindingBo bo);

    /**
     * 新增员工模板绑定及月度发放记录
     */
    Boolean insertByBo(OaEmployeeTemplateBindingBo bo);

    /**
     * 修改员工模板绑定及月度发放记录
     */
    Boolean updateByBo(OaEmployeeTemplateBindingBo bo);

    /**
     * 校验并批量删除员工模板绑定及月度发放记录信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    Boolean calculateSalary(List<Long> employeeIds, Long payYear, Long payMonth,Long defaultInsuranceTemplateId, Long defaultSalaryTemplateId);
    Boolean finalizeSalary(List<String> bindingIds);
    List<EmployeeSalaryRecordVo> querySalaryHistory(Long employeeId);
}
